%%%%%% approssimazione ad us sistema del secondo ordine a poli dominanti

clear all;
close all;

wn = 1;
xi = 0.7;
Tfin = 10; 

P0 = tf([wn^2],[1 2*xi*wn wn^2]);

%%%% verifica effetto di xi

figure(1);
[y,t] = step(P0,Tfin);
plot(t,y,'linewidth',2);
title('Effetto di coefficente di smorzamento');
hold on;


N =10;  %numero di curve
xi = linspace(0.1,2,N);  % campionamento di xi

for i=1:N
    P = tf([wn^2],[1 2*xi(i)*wn wn^2]);
    [y,t] = step(P,Tfin);
    plot(t,y,'r');
    s = sprintf('\\xi = %0.2g',xi(i));
    h=text(7,1.2,s,'fontsize',15);
    pause;
    delete(h);
end


%%%% verifica effetto di wn

figure(2);
[y,t] = step(P0,Tfin);
plot(t,y,'linewidth',2);
title('Effetto della frequenza naturale \omega_n');
hold on;


N =10;  %numero di curve
wn = linspace(0.2,5,N);  % campionamento di xi
xi = 0.7;

for i=1:N
    P = tf([wn(i)^2],[1 2*xi*wn(i) wn(i)^2]);
    [y,t] = step(P,Tfin);
    plot(t,y,'r');
    s = sprintf('\\omega_n = %0.2g',wn(i));
    h=text(7,1.2,s,'fontsize',15);
    pause;
    delete(h);
end

    
%%%% verifica effetto di zero positivo  (fase minima)  

figure(3);
[y,t] = step(P0,Tfin);
plot(t,y,'linewidth',2);
title('Effetto di zero negativo');
hold on;

alpha = linspace(1,10,N);  % effetto di uno zero z0=alpha*xi*wn
xi = 0.7;  %valori standard per un sistema del secondo ordine
wn =1;

for i=1:N
    P = tf(wn^2*[1/(alpha(i)*xi*wn) 1],[1 2*xi*wn wn^2]);
    [y,t] = step(P,Tfin);
    plot(t,y,'r');
    s = sprintf('\\alpha = %0.2g',alpha(i));
    h=text(7,1.2,s,'fontsize',15);
    pause;
    delete(h);
end
 
%%%% verifica effetto di zero negativo  (fase non minima)  

figure(4);
[y,t] = step(P0,Tfin);
plot(t,y,'linewidth',2);
title('Effetto di zero positivo');
hold on;

alpha = linspace(-1,-10,N);  % effetto di uno zero z0=alpha*xi*wn
xi = 0.7;

for i=1:N
    P = tf(wn^2*[1/(alpha(i)*xi*wn) 1],[1 2*xi*wn wn^2]);
    [y,t] = step(P,Tfin);
    plot(t,y,'r');
    s = sprintf('\\alpha = %0.2g',alpha(i));
    h=text(7,1.2,s,'fontsize',15);
    pause;
    delete(h);
end

%%%% verifica effetto di polo positivo addizionale (3ordine)  

figure(5);
[y,t] = step(P0,Tfin);
plot(t,y,'linewidth',2); 
title('Effetto di polo addizionale veloce');
hold on;

alpha = linspace(1,10,N);  % effetto di uno zero z0=alpha*xi*wn
xi = 0.7;

for i=1:N
    P = tf(1,[1/(alpha(i)*xi*wn) 1]);
    [y,t] = step(P0*P,Tfin);
    plot(t,y,'r');
    s = sprintf('\\alpha = %0.2g',alpha(i));
    h=text(7,1.2,s,'fontsize',15);
    pause;
    delete(h);
end

